<script setup lang="ts">
import { ref } from "vue";
import { useDropZone } from "@vueuse/core";
import UploadBackground from "@/assets/images/upload-bg.svg?component";
import type { ImagePreview } from "@/models/image";

defineProps<{
  previewImage?: ImagePreview;
  modelValue: File | undefined;
}>();

const emit = defineEmits<{ (e: "update:modelValue", file: File): void }>();

const dropZoneRef = ref(null);

function onDrop(files: File[] | null) {
  if (!files || !files.length) {
    return;
  }

  emit("update:modelValue", files[0]);
}

const { isOverDropZone } = useDropZone(dropZoneRef, onDrop);
</script>

<template>
  <div
    ref="dropZoneRef"
    class="wrapper"
    :class="{ active: isOverDropZone }"
    aria-hidden="true"
  >
    <UploadBackground v-if="!previewImage" class="placeholder" />
    <img
      v-else
      :src="previewImage.url"
      :title="previewImage.name"
      :alt="previewImage.name"
      class="preview"
    />
    <div class="text-hints">
      <p v-if="previewImage?.name" class="image-name">
        {{ previewImage.name }}
      </p>
      <p class="action">
        {{ isOverDropZone ? "Drop your image here" : "Drag your image here" }}
      </p>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.wrapper {
  outline: 1px dashed var(--color-primary-light);
}

.active {
  outline-width: 0.3rem;
  outline-style: solid;
}

.placeholder {
  width: 11.5rem;
  height: 9rem;
}

.preview {
  width: 85%;
  object-fit: cover;
  object-position: center;
  border-radius: 0.8rem;
}

.error {
  color: var(--color-alert);
  margin-bottom: 1rem;
}

.text-hints {
  text-align: center;
}

.image-name {
  margin-bottom: 1.5rem;
}

.action {
  color: var(--color-grey-light);
}
</style>
